#ifndef BOOTFUNC_H
#define BOOTFUNC_H
#include <stdint.h>
//******************************************************************************
//                                  Type Define
//******************************************************************************

// typedef unsigned int    uint32_t;
// typedef unsigned short  uint16_t;
// typedef unsigned char   uint8_t;

//******************************************************************************
//                                 Macro Define                                 
//******************************************************************************

// #define inw(reg)        (*((volatile unsigned int *) (reg)))
// #define outw(reg, data) ((*((volatile unsigned int *)(reg)))=(unsigned int)(data))
// 
// #define ins(reg)        (*((volatile unsigned short int *) (reg)))
// #define outs(reg, data) ((*((volatile unsigned short int *)(reg)))=(unsigned short int)(data))
// 
// #define inb(reg)        (*((volatile unsigned char *) (reg)))
// #define outb(reg, data) ((*((volatile unsigned char *)(reg)))=(unsigned char)(data))

//******************************************************************************
//                                Function Define                               
//******************************************************************************

void InitTable (void);

typedef int (*FlashOpEn_t)(void);
typedef int (*FlashOpDis_t)(void);
typedef int (*FlashProtReRead_t)(void);
typedef int (*BurnWord_t)(uint32_t addr, uint32_t data);
typedef int (*BurnPage_t)(uint32_t addr, uint32_t *data, int len);
typedef int (*SectorErase_t)(uint32_t addr);
typedef uint32_t (*CRC_t)(uint32_t starta, uint32_t stopa);
typedef uint32_t (*FASTBLANK_t)(uint32_t starta, uint32_t stopa);

typedef int (*Flash_Protect_t)(uint32_t key);
typedef void (*reStart_t)(void); 
typedef uint32_t (*chkprot_t)(void); 



typedef struct isp_func_t {
    FlashOpEn_t FlashOpEn;
    FlashOpDis_t FlashOpDis;
    FlashProtReRead_t FlashProtReRead;
    BurnWord_t BurnWord;
    BurnPage_t BurnPage;
    SectorErase_t SectorErase;
    CRC_t CRC;
    Flash_Protect_t Flash_Protect;
    reStart_t reStart;
    chkprot_t chkprot;
    FASTBLANK_t fastBlank;
} isp_func_set;


#define ISP_FUNC_ROMP ((isp_func_set *)0x81780)


#endif  // BOOTFUNC_H
