/*
 * DrvADC.c
 *
 *  Created on: 2011/11/14
 *      Author: 
 */
#include "DrvADC.h"
#include "SpecialMacro.h"

unsigned int DrvADC_PInputChannel(unsigned int uINP)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL2;
  if(uINP<(ADINP_MAX+1))
  {
    l_data=inw(l_reg)&0xFFFF0F0F;
    l_data|=(uINP<<ADINP)|(15<<(ADINP+MASK));
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}

unsigned int DrvADC_NInputChannel(unsigned int uINN)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL2;
  if(uINN<(ADINN_MAX+1))
  {
    l_data=inw(l_reg)&0xFFFFF0F0;
    l_data|=(uINN<<ADINN)|(15<<(ADINN+MASK));
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}

unsigned int DrvADC_SetADCInputChannel(unsigned int uINP,unsigned int uINN)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL2;
  if((uINP<(ADINP_MAX+1))&&(uINN<(ADINN_MAX+1)))
  {
    l_data=inw(l_reg)&0xFFFF0000;
    l_data|=(uINP<<ADINP)|(0xF<<(ADINP+MASK))|(uINN<<ADINN)|(0xF<<(ADINN+MASK));
    outw(l_reg,l_data);
  }else
    return E_DRVADC_ARGUMENT;
  return 0;
}

unsigned int DrvADC_InputSwitch(unsigned int uVISHR)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL1;
  if(uVISHR<(VISHR_MAX+1))
  {
    l_data=(uVISHR<<VISHR)|(VISHR_MAX<<(VISHR+MASK));
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}

unsigned int DrvADC_RefInputShort(unsigned int uVrshr)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL1;
  if(uVrshr<(VRSHR_MAX+1))
  {
    l_data=(uVrshr<<VRSHR)|(VRSHR_MAX<<(VRSHR+MASK));
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}

unsigned int DrvADC_SetPGA(unsigned int uPGA)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL2;
  if(uPGA<(PGA_MAX+1))
  {
    l_data=(inw(l_reg)&(0xFFFFFFFF-(PGA_MAX<<PGA)));
    l_data|=(uPGA<<PGA);
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}

unsigned int DrvADC_ADGain(unsigned int uADgain)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL2;
  if(uADgain<(ADGN_MAX+1))
  {
    l_data=(inw(l_reg)&(0xFFFFFFFF-(ADGN_MAX<<ADGN)));
    l_data|=(uADgain<<ADGN);
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}

unsigned int DrvADC_Gain(unsigned int uPGA ,unsigned int uADgain)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL2;
  if((uPGA<(PGA_MAX+1))&&(uADgain<(ADGN_MAX+1)))
  {
    l_data=(inw(l_reg)&(0xFFFFFFFF-(ADGN_MAX<<ADGN))&(0xFFFFFFFF-(PGA_MAX<<PGA)));
    l_data|=((uPGA<<PGA)|(uADgain<<ADGN));
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}

unsigned int DrvADC_DCoffset(unsigned int uDCoffset)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL2;
  if(uDCoffset<(DCSET_MAX+1))
  {
    l_data=(inw(l_reg)&(0xFFFFFFFF-(DCSET_MAX<<DCSET)));
    l_data|=(uDCoffset<<DCSET);
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}

unsigned int DrvADC_INXSet(unsigned int uINX)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL2;
  if(uINX<(INX_MAX+1))
  {
    l_data=inw(l_reg)&(0xFFFF0000);
    l_data|=(uINX<<INX);
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}

unsigned int DrvADC_RefVoltage(unsigned int uVrps,unsigned int uVrns)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL1;
  if((uVrps<(VRPS_MAX+1))&&(uVrns<(VRNS_MAX+1)))
  {
    l_data=(uVrps<<VRPS)|(VRPS_MAX<<(VRPS+MASK))|(uVrns<<VRNS)|(VRNS_MAX<<(VRNS+MASK));
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}

unsigned int DrvADC_FullRefRange(unsigned int uFullRange)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL2;
  if(uFullRange<(FRb_MAX+1))
  {
    l_data=(inw(l_reg)&(0xFFFFFFFF-(FRb_MAX<<FRb)));
    l_data|=(uFullRange<<FRb);
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}

unsigned int DrvADC_OSR(unsigned int uADCOSR)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL1;
  if(uADCOSR<(OSR_MAX+1))
  {
    l_data=(uADCOSR<<OSR)|(OSR_MAX<<(OSR_MASK));
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}

unsigned int DrvADC_ACM(E_ADC_ACMS uACMS)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL1;
  if(uACMS<(ACMS_MAX+1))
  {
    l_data=(uACMS<<ACMS)|(ACMS_MAX<<(ACMS_MASK));
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}

/*******************************************************************
*name    : DrvADC_ClkEnable(unsigned int uADCD)
*function: Enable ADC CLOCK,set the clock divider,the ADC clock adjustment
*input   : uADCD
*output  : 0 success
*          others: fail
*date    : 2016-7-19 (Authot Robert)
*modify  : no
*********************************************************************/
unsigned int DrvADC_ClkEnable(unsigned int uADCD)
{
	unsigned int l_reg,l_data,ReturnVal;
	ReturnVal=0;
	l_reg=R_ADC_CLOCK;
	if((uADCD<(ADC_CLK_DIV_MAX+1))&&(uADCD!=0))
	{
		l_data=inw(l_reg)&0x00007000;
		l_data|=(uADCD<<ADC_CLK_DIV)|(ADC_CLK_DIV_MAX<<ADC_CLK_DIV_MASK);  //set 0X4030C[6:4]=xxxb
		outw(l_reg,l_data);
	}else ReturnVal=E_DRVADC_ARGUMENT;
	return ReturnVal;
}

/*******************************************************************
*name    : DrvADC_ClkDisable(void)
*function: /set 0X4030C[6:4]=000b
*input   : no
*output  : no
*          others: no
*date    : 2016-7-19 (Authot Robert)
*modify  : no
*********************************************************************/
void DrvADC_ClkDisable(void)
{
	unsigned int l_reg,l_data; //Robert modify 2016/7/17
	l_reg=R_ADC_CLOCK;
    l_data=0x00007000; //set 0X4030C[6:4]=000b
	outw(l_reg,l_data);
}
/*
unsigned int DrvADC_FastChopper(unsigned int uADFDR)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL1;
  if(uADFDR<(ADFDR_MAX+1))
  {
    l_data=(uADFDR<<ADFDR)|(ADFDR_MAX<<(ADFDR_MASK));
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}
*/
unsigned int DrvADC_CombFilter(unsigned int uCFRST)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL1;
  if(uCFRST<(CFRST_MAX+1))
  {
    l_data=(uCFRST<<CFRST)|(CFRST_MAX<<(CFRST_MASK));
    outw(l_reg,l_data);
  }else return E_DRVADC_ARGUMENT;
  return 0;
}

void DrvADC_EnableInt(void)
{
  unsigned int l_reg,l_data;
  l_reg=ADC_INTERRUPT_CTRL;
  l_data=(1<<ADCIE)|(1<<ADCIE_MASK);
  outw(l_reg,l_data);
}

void DrvADC_DisableInt(void)
{
  unsigned int l_reg,l_data;
  l_reg=ADC_INTERRUPT_CTRL;
  l_data=(1<<ADCIE_MASK);
  outw(l_reg,l_data);
}

/*******************************************************************
*name    : DrvADC_ReadIntFlag(void)
*function: Get the ADC interrupt flag
*input   : NO
*output  : 0 ADC flag is 0,have no interrupt
*          1 ADC flag is 1,it's ADC interrupt
*date    : 2013-11-29
*modify  : modify the operation about get ADC flag correctly
*********************************************************************/
unsigned int DrvADC_ReadIntFlag(void)
{
  unsigned int l_reg;

  l_reg=ADC_INTERRUPT_CTRL;

  return ((inw(l_reg)&0x01)>>(ADCIF)); //Read 0X40008[0]
}

void DrvADC_ClearIntFlag(void)
{
  unsigned int l_reg,l_data;

  l_reg=ADC_INTERRUPT_CTRL;
  l_data=(1<<ADCIF_MASK);
  outw(l_reg,l_data);
}

void DrvADC_Enable(void)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL1;
  l_data=(1<<ADCEN)|(1<<ADCEN_MASK);
  outw(l_reg,l_data);
}

void DrvADC_Disable(void)
{
  unsigned int l_reg,l_data;

  l_reg=R_ADC_CTRL1;
  l_data=(1<<ADCEN_MASK);
  outw(l_reg,l_data);
}

/*******************************************************************
*name    : DrvADC_GetConversionData()
*function: read the ADC register 32bit
*input   : no
*output  : ADC register 32bit
*date    : 2013-11-29
*modify  : modify the return data type from 'unsigned int' to 'int'
*********************************************************************/
int DrvADC_GetConversionData(void)
{
  unsigned int l_reg;
  int l_data;

  l_reg=R_ADC_ADO;
  l_data=inw(l_reg);
  return l_data;
}
