/*
 * DrvClock.c
 *
 *  Created on: 2014/5
 *      Author:
 */
#include "DrvClock.h"
#include "SpecialMacro.h"

/*******************************************************************
*name    : DrvCLOCK_EnableHighOSC
*function: }Ұt_äCPU
*input   : usource/ delay
*output  : 0 success /1 fail
*Version : v1.1
*date    : 2014-2-12
*modify  : K[_FíwɶѼƳ]m
*********************************************************************/
unsigned int DrvCLOCK_EnableHighOSC(unsigned int uSource,unsigned int delay)
{
  unsigned int l_reg,l_data,ReturnVal,x,y;
  ReturnVal=0;
  l_reg=R_CLOCK_CTRL1;
  if(uSource>1){return E_DRVCLOCK_ARGUMENT;}
  else{
    /*if(uSource==1)
      l_data=(uSource<<HSel)|(1<<HSel_MASK)|(1<<ENOHS)|(1<<ENOHS_MASK);
    else
      l_data=(uSource<<HSel)|(1<<HSel_MASK)|(1<<ENHAO)|(1<<ENHAO_MASK);*/
    if(uSource==1)
      l_data=(1<<ENOHS)|(1<<ENOHS_MASK);
    else
      l_data=(1<<ENHAO)|(1<<ENHAO_MASK);
    outw(l_reg,l_data);
    for(x=0;x<4*delay;x++)
    {
       for(y=0;y<1000;y++)
         asm("nop");
    }
    if(uSource==1)
      l_data=(uSource<<HSel)|(1<<HSel_MASK)|(1<<ENHAO_MASK);
    else
      l_data=(uSource<<HSel)|(1<<HSel_MASK)|(1<<ENOHS_MASK);
  }
  outw(l_reg,l_data);
  return ReturnVal;
}

void DrvCLOCK_CloseEHOSC()
{
  unsigned int l_reg,l_data;
  l_reg=R_CLOCK_CTRL1;
  l_data=(1<<ENOHS_MASK);
  outw(l_reg,l_data);
}

void DrvCLOCK_CloseIHOSC()
{
  unsigned int l_reg,l_data;
  l_reg=R_CLOCK_CTRL1;
  l_data=(1<<ENHAO_MASK);
  outw(l_reg,l_data);
}

unsigned int DrvCLOCK_SelectIHOSC(unsigned int uMode)
{
  unsigned int l_reg,l_data,ReturnVal;
  ReturnVal=0;
  l_reg=R_CLOCK_CTRL1;
  if(uMode>HAMO_MAX){return E_DRVCLOCK_ARGUMENT;}
  else{
    l_data=(uMode<<HAMO)|(HAMO_MAX<<HAMO_MASK);
  }
  outw(l_reg,l_data);
  return ReturnVal;
}

unsigned int DrvCLOCK_SelectIHOSC_CalHAO(unsigned int uMode)
{
  unsigned int l_reg,l_data,uMHZ,ReturnVal;
  ReturnVal=0;
  l_reg=R_CLOCK_CTRL1;
//cheng HAO frequency 
  if(uMode>HAMO_MAX){return E_DRVCLOCK_ARGUMENT;}
  else{
    l_data=(uMode<<HAMO)|(HAMO_MAX<<HAMO_MASK);
  }
  outw(l_reg,l_data);

//calibrate the HAO value
  if(uMode==1)
  {uMHZ=1;}
  else
  {uMHZ=2;}    
  if(((inw(Trim_HAO_4MHZ_Burner)!=0xFFFFFFFF)) && ((inw(Trim_HAO_4MHZ_Burner+4)!=0xFFFFFFFF)))  //0xB1C00~0xB1C07 not empty
  {
    if(((inw(Trim_HAO_4MHZ_Burner)&0xFFFFFF00)==0) && ((inw(Trim_HAO_4MHZ_Burner+4)&0xFFFFFF00)==0))  //0xB1C01~0xB1C03 is 0x00 and 0xB1C05~0xB1C07 is 0x00
    {
      l_data=(inw((Trim_HAO_4MHZ_Burner+uMHZ*4)-4)&0xff)+0xff00;
    }
    else
    {
      l_reg=Trim_HAO_4MHZ+uMHZ*4;
      l_data=(inw(l_reg)&0xff)+0xff00;
    }
  }
  else
  {
    l_reg=Trim_HAO_4MHZ+uMHZ*4;
    l_data=(inw(l_reg)&0xff)+0xff00;
  }
  l_reg=R_CLOCK_TRIM;
  outw(l_reg,l_data);  
  return ReturnVal;
}

/**********************************************************************
 * Name     : DrvCLOCK_EnableLowOSC(unsigned int uSource,unsigned int udelay)
 * function : choose the low clock source and setting the delay time self
 * input    : usource/udelay
 * output   : 0 success
 *            others: fail
 * version  : v1.1
 * date     : 13-12-4
 * modify   : add input parament to control the delay time.
 *********************************************************************/
unsigned int DrvCLOCK_EnableLowOSC(unsigned int uSource,unsigned int udelay)
{
  unsigned int l_reg,l_data,ReturnVal,x;
  ReturnVal=0;
  l_reg=R_CLOCK_CTRL1;
  if(uSource>1){return E_DRVCLOCK_ARGUMENT;}
  else{
    if(uSource==1){
      l_data=(1<<ENOLS)|(1<<ENOLS_MASK);
      outw(l_reg,l_data);
      for(x=0;x<udelay;x++) //(x=0;x<1300;x++)
      {
         //for(y=0;y<1000;y++)
           asm("nop");
      }
    }
  }
  l_data=(uSource<<LSel)|(1<<LSel_MASK);
  outw(l_reg,l_data);
  return ReturnVal;
}

void DrvCLOCK_CloseELOSC()
{
  unsigned int l_reg,l_data;
  l_reg=R_CLOCK_CTRL1;
  l_data=(1<<ENOLS_MASK);
  outw(l_reg,l_data);
}

unsigned int DrvCLOCK_SelectMCUClock(unsigned int uSource,unsigned int uDiv)
{
  unsigned int l_reg,l_data,ReturnVal;
  ReturnVal=0;
  l_reg=R_CLOCK_CTRL2;
  if((uSource>CSel_MAX)|(uDiv>ENMCD_MAX)){return E_DRVCLOCK_ARGUMENT;}
  else{
    l_data=(uSource<<CSel)|(CSel_MAX<<CSel_MASK)|(uDiv<<ENMCD)|(ENMCD_MAX<<ENMCD_MASK);
  }
  outw(l_reg,l_data);
  return ReturnVal;
}

unsigned int DrvCLOCK_TrimHAO(unsigned int uTrim)
{
  unsigned int l_reg,l_data,ReturnVal;
  ReturnVal=0;
  l_reg=R_CLOCK_TRIM;
  if(uTrim>HAOTR_MAX){return E_DRVCLOCK_ARGUMENT;}
  else{
    l_data=(uTrim<<HAOTR)|(HAOTR_MAX<<HAOTR_MASK);
  }
  outw(l_reg,l_data);
  return ReturnVal;
}

/********************************************************************
 * name    : DrvCLOCK_CalHAO(short int uMHZ)
 * function: calibrate the HAO value
 * input   : uMHZ:1--4MHZ/2---32MHZ
 * output  : no
 * date    : 2021-7-20
 * modify  : no
 ********************************************************************/
void DrvCLOCK_CalibrateHAO(short int uMHZ)
{
  unsigned int l_reg,l_data;

  if(((inw(Trim_HAO_4MHZ_Burner)!=0xFFFFFFFF)) && ((inw(Trim_HAO_4MHZ_Burner+4)!=0xFFFFFFFF)))  //0xB1C00~0xB1C07 not empty
  {
    if(((inw(Trim_HAO_4MHZ_Burner)&0xFFFFFF00)==0) && ((inw(Trim_HAO_4MHZ_Burner+4)&0xFFFFFF00)==0))  //0xB1C01~0xB1C03 is 0x00 and 0xB1C05~0xB1C07 is 0x00
    {
      l_data=(inw((Trim_HAO_4MHZ_Burner+uMHZ*4)-4)&0xff)+0xff00;
    }
    else
    {
      l_reg=Trim_HAO_4MHZ+uMHZ*4;
      l_data=(inw(l_reg)&0xff)+0xff00;
    }
  }
  else
  {
    l_reg=Trim_HAO_4MHZ+uMHZ*4;
    l_data=(inw(l_reg)&0xff)+0xff00;
  }
  l_reg=R_CLOCK_TRIM;
  outw(l_reg,l_data);
}

unsigned int DrvCLOCK_SelectOHS_HS(unsigned int uMode)
{
  unsigned int l_reg,l_data,ReturnVal;
  ReturnVal=0;
  l_reg=R_CLOCK_CTRL1;
  if(uMode<(1+1))
  {
    l_data=(uMode<<7)|(1<<(7+8));
    outw(l_reg,l_data);
  }else ReturnVal=E_DRVCLOCK_ARGUMENT;
  return ReturnVal;
}
