/*
 * DrvClock.h
 *
 *  Created on: 2014/5
 *      Author: 
 */

#ifndef DRVCLOCK_H_
#define DRVCLOCK_H_

#include "HY16F391.h"

#ifndef E_FAIL
#define E_FAIL    1
#endif
#define E_DRVCLOCK_ARGUMENT E_FAIL

#ifndef E_SUCCESS
#define E_SUCCESS    0
#endif

typedef enum
{
  E_INTERNAL = 0,
  E_EXTERNAL  = 1
} E_CLOCK_SOURCE;

typedef enum
{
  E_HSCK = 0,
  E_LSCK  = 1
} E_MCUCK_SOURCE;

typedef enum
{
  //E_Rev = 0,
  E_HAO_4M  = 1,
  //E_Rev =2
  E_HAO_32M = 3
} E_HAO_CLOCK;

typedef enum
{
  MCUCKDIV2 = 0,
  MCUCKDIV4 = 1,
  MCUCKDIV8 = 2,
  MCUCKDIV1 = 3
} E_MCUCK_Prescale;

typedef enum
{
  //TRIM_HAO2MHZ= 0,
  TRIM_HAO4MHZ=1,
  //TRIM_HAO10MHZ,
  TRIM_HAO32MHZ=2
} E_TRIM_FREQUEN;

#ifdef  CLOCK_BASE
#define R_CLOCK_CTRL1 (CLOCK_BASE+OFFSET00)
#define R_CLOCK_TRIM  (CLOCK_BASE+OFFSET04)
#define R_CLOCK_CTRL2 (CLOCK_BASE+OFFSET08)

#define Trim_HAO_4MHZ          0xB1800
#define Trim_HAO_4MHZ_Burner   0xB1C00
#endif

#define LSel           6
#define HSel           5
#define HAMO           3
#define ENOLS          2
#define ENOHS          1
#define ENHAO          0
#define LSel_MASK      (LSel+MASK)
#define HSel_MASK      (HSel+MASK)
#define HAMO_MASK      (HAMO+MASK)
#define ENOLS_MASK     (ENOLS+MASK)
#define ENOHS_MASK     (ENOHS+MASK)
#define ENHAO_MASK     (ENHAO+MASK)
#define HAMO_MAX       3

#define HAOTR          0
#define HAOTR_MASK     (HAOTR+MASK)
#define HAOTR_MAX      255

#define ENMCD          19
#define CSel           0
#define ENMCD_MASK     (ENMCD+MASK)
#define CSel_MASK      (CSel+MASK)
#define ENMCD_MAX      3
#define CSel_MAX       1

#define Wakeup2HAO 			18
#define IDLEHAODIS    		17
#define LPOKeep    			16
#define Wakeup2HAO_MASK 	(Wakeup2HAO+MASK)
#define IDLEHAODIS_MASK		(IDLEHAODIS+MASK)
#define LPOKeep_MASK		(LPOKeep+MASK)

unsigned int DrvCLOCK_EnableHighOSC(unsigned int uSource,unsigned int delay);
void DrvCLOCK_CloseEHOSC();
void DrvCLOCK_CloseIHOSC();
unsigned int DrvCLOCK_SelectIHOSC_CalHAO(unsigned int uMode);
unsigned int DrvCLOCK_SelectIHOSC(unsigned int uMode);
unsigned int DrvCLOCK_EnableLowOSC(unsigned int uSource,unsigned int udelay);
void DrvCLOCK_CloseELOSC();
unsigned int DrvCLOCK_SelectMCUClock(unsigned int uSource,unsigned int uDiv);
unsigned int DrvCLOCK_TrimHAO(unsigned int uTrim);

void DrvCLOCK_CalibrateHAO(short int uMHZ);
unsigned int DrvCLOCK_SelectOHS_HS(unsigned int uMode);


#endif /* DRVCLOCK_H_ */
