/*
 * GPIO_lib.c
 *
 *  Created on: 2011/11/1
 *      Author:
 */

#include "DrvGPIO.h"
#include "SpecialMacro.h"

/*******************************************************************
*name    : unsigned int DrvGPIO_Open()
*function: IOfu@Ҧ}
*input   : port: IO fF i32Bit:ݳ]mIO޸}Fmode: IOfu@Ҧ
*output  : 0G\FLGѡF
*Version : v1.0
*date    : 2020-9-28
*modify  : קXҦBWԹqҦާ@]mAקP@ؼҦ]me]mл\{H
*          קDrvGPIO_OPEN()ơAR]mJ/XɡAP޸}X/J\ 2015-2-4
*********************************************************************/
unsigned int DrvGPIO_Open(uint32_t port,uint32_t i32Bit,uint32_t mode )
{
  uint32_t l_reg,l_data,ReturnVal;
  ReturnVal=0;
  if (port==1) {l_reg=PT1_BASE;}
  else if (port==2) {l_reg=PT2_BASE;}
  else if (port==3) {l_reg=PT3_BASE;}
  else {ReturnVal=E_DRVGPIO_ARGUMENT;}
  switch (mode)
  {
    case 0:
      if (i32Bit > 0xff){ReturnVal=E_DRVGPIO_ARGUMENT; break;}

      l_data=(i32Bit<<16)+(i32Bit<<24);
      l_reg=l_reg+OFFSET04;
      outw(l_reg, l_data);
        break;
    case 1:
      if (i32Bit > 0xff){ReturnVal=E_DRVGPIO_ARGUMENT; break;}

      l_data=(i32Bit<<8)|i32Bit;
      outw(l_reg, l_data);
        break;
    case 2:
      if (i32Bit > 0xff){ReturnVal=E_DRVGPIO_ARGUMENT; break;}
      l_data=(i32Bit<<16)|(i32Bit<<24);
      outw(l_reg, l_data);
        break;
    case 3:
      if (port>3){ReturnVal=E_DRVGPIO_ARGUMENT; break;}
      if (i32Bit > 0xff){ReturnVal=E_DRVGPIO_ARGUMENT; break;}
      l_data=(i32Bit<<16)+(i32Bit<<24);
      //l_reg=(INTERRUPT_BASE+OFFSET10)+(port*4-4);
      if (port==1) {l_reg=INTERRUPT_BASE+OFFSET10;}
      else if (port==2) {l_reg=INTERRUPT_BASE+OFFSET14;}
      else if (port==3) {l_reg=INTERRUPT_BASE+OFFSET20;}
      outw(l_reg, l_data);

      break;
  }
  return ReturnVal;
}

/*******************************************************************
*name    : unsigned int DrvGPIO_Close()
*function: IOfu@Ҧ
*input   : port:IOfF i32Bit:ݳ]mIO޸}F mode:u@Ҧ
*output  : 0G\FL: ѡF
*Version : v1.0
*date    : 2020-9-28
*modify  : NO
*********************************************************************/
unsigned int DrvGPIO_Close(uint32_t port,uint32_t i32Bit,uint32_t mode )
{
  uint32_t l_reg,l_data,ReturnVal;
  ReturnVal=0;
  if (port==1) {l_reg=PT1_BASE;}
  else if (port==2) {l_reg=PT2_BASE;}
  else if (port==3) {l_reg=PT3_BASE;}
  else {ReturnVal=E_DRVGPIO_ARGUMENT;}
  switch (mode)
  {
    case 0:
      if (i32Bit > 0xff){ReturnVal=E_DRVGPIO_ARGUMENT; break;}
      l_data=(i32Bit<<24)&0xff000000;
      l_reg=l_reg+OFFSET04;
      outw(l_reg, l_data);
        break;

    case 1:
      if (i32Bit > 0xff){ReturnVal=E_DRVGPIO_ARGUMENT; break;}
      l_data=(i32Bit<<8)&0xff00;
      outw(l_reg, l_data);
      break;

    case 2:
      if (i32Bit > 0xff){ReturnVal=E_DRVGPIO_ARGUMENT; break;}
      l_data=(i32Bit<<24)&0xff000000;
      outw(l_reg, l_data);
        break;
    case 3:
      if (port>3){ReturnVal=E_DRVGPIO_ARGUMENT; break;}
      if (i32Bit > 0xff){ReturnVal=E_DRVGPIO_ARGUMENT; break;}
      l_data=(i32Bit<<24)&0xff000000;
      //l_reg=(INTERRUPT_BASE+OFFSET10)+(port*4-4);
      if (port==1) {l_reg=INTERRUPT_BASE+OFFSET10;}
      else if (port==2) {l_reg=INTERRUPT_BASE+OFFSET14;}
      else if (port==3) {l_reg=INTERRUPT_BASE+OFFSET20;}
      outw(l_reg, l_data);
      break;
  }
  return ReturnVal;
}
/*
*modify: RϯIO ~_\઺{    2015-09-22
*/
unsigned int DrvGPIO_IntTrigger( uint32_t port, uint32_t i32Bit, uint32_t mode)
{
  uint32_t l_reg,l_data,ReturnVal;
  ReturnVal=0;
  if (port==1) {l_reg=PT1_BASE+OFFSET0C;}
  else if (port==2) {l_reg=PT2_BASE+OFFSET0C;}
  else if (port==3) {l_reg=PT3_BASE+OFFSET0C;}
  else {return E_DRVGPIO_ARGUMENT;}

  if (mode<8)
    {
     if (i32Bit > 0xff){return E_DRVGPIO_ARGUMENT;}
       l_data=inw(l_reg)|(i32Bit<<24);
       if (i32Bit&(1<<0)) {l_data=(l_data&0xfffffff8)+mode;}
       if (i32Bit&(1<<1)) {l_data=(l_data&0xffffffc7)+(mode<<3);}
       if (i32Bit&(1<<2)) {l_data=(l_data&0xfffffe3f)+(mode<<6);}
       if (i32Bit&(1<<3)) {l_data=(l_data&0xfffff1ff)+(mode<<9);}
       if (i32Bit&(1<<4)) {l_data=(l_data&0xffff8fff)+(mode<<12);}
       if (i32Bit&(1<<5)) {l_data=(l_data&0xfffc7fff)+(mode<<15);}
       if (i32Bit&(1<<6)) {l_data=(l_data&0xffe3ffff)+(mode<<18);}
       if (i32Bit&(1<<7)) {l_data=(l_data&0xff1fffff)+(mode<<21);}
     outw(l_reg, l_data);
    }
  else
    {
      return E_DRVGPIO_ARGUMENT;
    }

  return ReturnVal;
}

/**********************************************************************************************
 *name    : DrvGPIO_PortIDIF
 *function: read the PORT interrupt trigger mode, the flag of IO PIN input status
 *input   : port: IO PORT : PT1/PT2/PT3
 *output  : the PORT OF IO PIN INPUT STATUS
 *version : V0.1
 *date    : 2020-09-28
 *note    : 
 *modify  :
 ***********************************************************************************************/
unsigned int DrvGPIO_PortIDIF( uint32_t port)
{
  uint32_t l_reg;

  if (port==1) {l_reg=PT1_BASE+OFFSET0C;}
  else if (port==2) {l_reg=PT2_BASE+OFFSET0C;}
  else if (port==3) {l_reg=PT3_BASE+OFFSET0C;}
  return (inw(l_reg)>>24);
}

unsigned int DrvGPIO_ClearIntFlag(E_DRVGPIO_PORT port,unsigned int uint32)
{
  unsigned int l_reg,l_data;
  l_data=(uint32<<8);
  if(port==1)
    {
      l_reg=GPIO_INTERRUPT_CTRL;
      outw(l_reg,l_data);
    }
  else if(port==2)
    {
      l_reg=GPIO_INTERRUPT_CTRL+OFFSET04;
      outw(l_reg,l_data);
    }
  else if(port==3)
    {
      l_reg=GPIO_INTERRUPT_CTRL+OFFSET10;
      outw(l_reg,l_data);
    }
  return (inw(GPIO_INTERRUPT_CTRL)&0x000000ff);
}

/*unsigned int DrvGPIO_ClkGenerator ( uint32_t uClk, uint32_t uDivider)
{
  uint32_t l_reg,l_data,ReturnVal;
  ReturnVal=0;
  l_reg=GOIP_CLOCK_BASE;
  if (uDivider>15) ReturnVal=E_DRVGPIO_ARGUMENT;
  if (uClk==0){l_data=0+uDivider;}
  else if (uClk==1){l_data=0x10+uDivider;}
  else {ReturnVal=E_DRVGPIO_ARGUMENT;}
  l_data=(l_data<<16)|0x1f000000;
  outw(l_reg, l_data);
  return ReturnVal;
}*/

unsigned int DrvGPIO_GetPortBits (unsigned int port)
{
  unsigned int l_reg;
//  ReturnVal=0;
  if (port==1) {l_reg=PT1_BASE;}
  else if (port==2) {l_reg=PT2_BASE;}
  else if (port==3) {l_reg=PT3_BASE;}
  //else if (port==4) {l_reg=PT4_BASE;}
  else {return E_DRVGPIO_ARGUMENT3;}
  l_reg=l_reg+OFFSET08;
  return inw(l_reg)&0x000000ff;
}

unsigned int DrvGPIO_SetPortBits (unsigned int uport, unsigned int ui32Data)
{
  unsigned int l_reg,l_data,ReturnVal;
  ReturnVal=0;
  if (uport==1) {l_reg=PT1_BASE;}
  else if (uport==2) {l_reg=PT2_BASE;}
  else if (uport==3) {l_reg=PT3_BASE;}
  //else if (uport==4) {l_reg=PT4_BASE;}
  else {ReturnVal=E_DRVGPIO_ARGUMENT;}
  l_reg=l_reg+OFFSET04;
  if (ui32Data>0xff) {ReturnVal=E_DRVGPIO_ARGUMENT;}
  //Robert modify 2016/7/28
  //else {l_data=(ui32Data|0x0000ff00);}
  else
  {l_data=(ui32Data|(ui32Data<<8));}
  outw(l_reg, l_data);
  return ReturnVal;
}

unsigned int DrvGPIO_ClrPortBits (unsigned int uport, unsigned int ui32Data)
{
  unsigned int l_reg,l_data,ReturnVal;
  ReturnVal=0;
  if (uport==1) {l_reg=PT1_BASE;}
  else if (uport==2) {l_reg=PT2_BASE;}
  else if (uport==3) {l_reg=PT3_BASE;}
  //else if (uport==4) {l_reg=PT4_BASE;}
  else {ReturnVal=E_DRVGPIO_ARGUMENT;}
  l_reg=l_reg+OFFSET04;
  if (ui32Data>0xff) {ReturnVal=E_DRVGPIO_ARGUMENT;}
  else {
    l_data=ui32Data<<8;
    //l_data=l_data|0x0000ff00;
  }
  outw(l_reg, l_data);
  return ReturnVal;
}

unsigned int DrvGPIO_GetBit (unsigned int port, unsigned int ui8Bit)
{
  uint32_t A,l_data,l_reg,ReturnVal;
  ReturnVal=0;
  if (port==1) {l_reg=PT1_BASE;}
  else if (port==2) {l_reg=PT2_BASE;}
  else if (port==3) {l_reg=PT3_BASE;}
  //else if (port==4) {l_reg=PT4_BASE;}
  else {ReturnVal=E_DRVGPIO_ARGUMENT3;}
  l_reg=l_reg+OFFSET08;
  l_data=inw(l_reg)&0x000000ff;
  if (ReturnVal!=E_DRVGPIO_ARGUMENT3){
    if (ui8Bit<8)
    {
    A=0;
    //for (i=0;i<ui8Bit;i++)
    A=0x1<<ui8Bit; //A*2;

    A=l_data&A;
      if (A!=0) ReturnVal=1;
      else ReturnVal=0;
    }
    else {ReturnVal=E_DRVGPIO_ARGUMENT3;}
  }
  return ReturnVal;
}

unsigned int DrvGPIO_SetBit (unsigned int uport, unsigned int i32Bit)
{
  uint32_t l_data,l_reg,ReturnVal;
  ReturnVal=0;
  if (uport==1) {l_reg=PT1_BASE;}
  else if (uport==2) {l_reg=PT2_BASE;}
  else if (uport==3) {l_reg=PT3_BASE;}
  //else if (uport==4) {l_reg=PT4_BASE;}
  else {ReturnVal=E_DRVGPIO_ARGUMENT2;}
  l_reg=l_reg+OFFSET04;
  if (i32Bit > 7){ReturnVal=E_DRVGPIO_ARGUMENT2;}
  else if (i32Bit==0) {l_data=0x00000101;}
  else if (i32Bit==1) {l_data=0x00000202;}
  else if (i32Bit==2) {l_data=0x00000404;}
  else if (i32Bit==3) {l_data=0x00000808;}
  else if (i32Bit==4) {l_data=0x00001010;}
  else if (i32Bit==5) {l_data=0x00002020;}
  else if (i32Bit==6) {l_data=0x00004040;}
  else if (i32Bit==7) {l_data=0x00008080;}
  else {ReturnVal=E_DRVGPIO_ARGUMENT2;}
  outw(l_reg, l_data);
  return ReturnVal;
}

unsigned int DrvGPIO_ClrBit (unsigned int uport, unsigned int i32Bit)
{
  uint32_t l_data,l_reg,ReturnVal;
  ReturnVal=0;
  if (uport==1) {l_reg=PT1_BASE;}
  else if (uport==2) {l_reg=PT2_BASE;}
  else if (uport==3) {l_reg=PT3_BASE;}
  //else if (uport==4) {l_reg=PT4_BASE;}
  else {ReturnVal=E_DRVGPIO_ARGUMENT2;}
  l_reg=l_reg+OFFSET04;
  if (i32Bit > 7){ReturnVal=E_DRVGPIO_ARGUMENT3;}
  else if (i32Bit==0) {l_data=0x00000100;}
  else if (i32Bit==1) {l_data=0x00000200;}
  else if (i32Bit==2) {l_data=0x00000400;}
  else if (i32Bit==3) {l_data=0x00000800;}
  else if (i32Bit==4) {l_data=0x00001000;}
  else if (i32Bit==5) {l_data=0x00002000;}
  else if (i32Bit==6) {l_data=0x00004000;}
  else if (i32Bit==7) {l_data=0x00008000;}
  else {ReturnVal=E_DRVGPIO_ARGUMENT3;}
  outw(l_reg, l_data);
  return ReturnVal;
}

uint32_t DrvGPIO_GetIntFlag(E_DRVGPIO_PORT port)
{
  unsigned int l_reg,l_data;
  if (port>3) return E_FAIL;
  if(port==1)
  {
    l_reg=GPIO_INTERRUPT_CTRL;
    l_data=inw(l_reg)&0xff;
    }
  else if(port==2)
  {
    l_reg=GPIO_INTERRUPT_CTRL+OFFSET04;
    l_data=inw(l_reg)&0xff;
    }
  else if(port==3)
  {
    l_reg=GPIO_INTERRUPT_CTRL+OFFSET10;
    l_data=inw(l_reg)&0xff;
    }    
  return l_data;
}
/*******************************************************************
*name    : DrvGPIO_LCDIOOpen()
*function: PT6~PT13IOfu@Ҧ}
*input   : port: IO fF i32Bit:ݳ]mIO޸},쬰1A~Q]mF
*          mode: IOfu@Ҧ 0  input mode 1 output mode
*output  : 0G\FLGѡF
*Version : v1.1
*date    : 2021-6-16
*modify  : [JPT10/PT13]m
*********************************************************************/
unsigned char DrvGPIO_LCDIOOpen(uint32_t port,uint32_t i32Bit,uint32_t mode )
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=i32Bit;
  if((port==5)||(port==6)||(port>7))
    return E_FAIL;
  if(mode>1)
    return E_FAIL;
  else if(mode==0) //input mode
    {
      for(i=0;i<4;i++)
      {
      l_data=(l_data&0x0)+((l_temp&0x1)<<LCDIO_IN)+((l_temp&0x01)<<LCDIO_IN_MASK);
      l_temp=l_temp>>1;
      l_data=((l_temp&0x1)<<(LCDIO_IN+16))+((l_temp&0x01)<<(LCDIO_IN_MASK+16))+l_data;
      l_temp=l_temp>>1;
      l_reg=port*0x10+GPIO_PT6+i*0x04;
      outw(l_reg,l_data);
      }
    }

  else if(mode==1) //output mode
    {
      for(i=0;i<4;i++)
      {
      l_data=(l_data&0x0)+((l_temp&0x1)<<LCDIO_OUT)+((l_temp&0x01)<<LCDIO_OUT_MASK);
      l_temp=l_temp>>1;
      l_data=((l_temp&0x1)<<(LCDIO_OUT+16))+((l_temp&0x01)<<(LCDIO_OUT_MASK+16))+l_data;
      l_temp=l_temp>>1;
      l_reg=port*0x10+GPIO_PT6+i*0x04;
      outw(l_reg,l_data);
      }
    }
  return E_SUCCESS;
}

/*******************************************************************
*name    : DrvGPIO_LCDIOClose()
*function: PT6~PT13IOfu@Ҧ}
*input   : port: IO fF i32Bit:ݳ]mIO޸}A쬰1A~Q]mF
*          mode: IOfu@Ҧ 0  input mode 1 output mode
*output  : 0G\FLGѡF
*Version : v1.1
*date    : 2021-6-16
*modify  : [JPT10/PT13]m
*********************************************************************/
unsigned char DrvGPIO_LCDIOClose(uint32_t port,uint32_t i32Bit,uint32_t mode )
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=i32Bit;
  if((port==5)||(port==6)||(port>7))
    return E_FAIL;
  if(mode>1)
    return E_FAIL;
  else if(mode==0) //input mode
    {
      for(i=0;i<4;i++)
      {
      l_data=(l_data&0x0)+(0x0<<LCDIO_IN)+((l_temp&0x01)<<LCDIO_IN_MASK);
      l_temp=l_temp>>1;
      l_data=(0x0<<(LCDIO_IN+16))+((l_temp&0x01)<<(LCDIO_IN_MASK+16))+l_data;
      l_temp=l_temp>>1;
      l_reg=port*0x10+GPIO_PT6+i*0x04;
      outw(l_reg,l_data);
      }

    }

  else if(mode==1) //output mode
    {
      for(i=0;i<4;i++)
      {
      l_data=(l_data&0x0)+(0x0<<LCDIO_OUT)+((l_temp&0x01)<<LCDIO_OUT_MASK);
      l_temp=l_temp>>1;
      l_data=(0x0<<(LCDIO_OUT+16))+((l_temp&0x01)<<(LCDIO_OUT_MASK+16))+l_data;
      l_temp=l_temp>>1;
      l_reg=port*0x10+GPIO_PT6+i*0x04;
      outw(l_reg,l_data);
      }
    }

  return E_SUCCESS;
}

/*******************************************************************
*name    : DrvGPIO_LCDIOSetPorts()
*function: PT6~PT13IOfX
*input   : port: IO f 0~5 F
*          i32Bit:IO޸}ȡAIO port@_]mȾާ@Ad0~0XFFF
*output  : 0G\FLGѡF
*Version : v1.1
*date    : 2021-6-16
*modify  : [JPT10/PT13]m
*********************************************************************/
unsigned char DrvGPIO_LCDIOSetPorts(uint32_t port,uint32_t i32Bit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=i32Bit;
  if((port==5)||(port==6)||(port>7))
    return E_FAIL;

  for(i=0;i<4;i++)
  {
  l_data=(l_data&0x0)+(0x01<<LCDIO_DO)+((l_temp&0x1)<<LCDIO_DO_MASK);
  l_temp=l_temp>>1;
  l_data=(0x01<<(LCDIO_DO+16))+((l_temp&0x1)<<(LCDIO_DO_MASK+16))+l_data;
  l_temp=l_temp>>1;
  l_reg=port*0x10+GPIO_PT6+i*0x04;
  outw(l_reg,l_data);
  }

  return E_SUCCESS;
}

/*******************************************************************
*name    : DrvGPIO_LCDIOClrPorts()
*function: PT6~PT13IOfXȳQMs
*input   : port: IO f 0~5 F
*          i32Bit:IO޸}ȡAIO port@_]mȾާ@Ad0~0XFFF
*output  : 0G\FLGѡF
*Version : v1.1
*date    : 2021-6-16
*modify  : [JPT10/PT13]m
*********************************************************************/
unsigned char DrvGPIO_LCDIOClrPorts(uint32_t port,uint32_t i32Bit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=i32Bit;
  if((port==5)||(port==6)||(port>7))
    return E_FAIL;

  for(i=0;i<4;i++)
  {
  l_data=(l_data&0x0)+(0x0<<LCDIO_DO)+((l_temp&0x1)<<LCDIO_DO_MASK);
  l_temp=l_temp>>1;
  l_data=(0x0<<(LCDIO_DO+16))+((l_temp&0x1)<<(LCDIO_DO_MASK+16))+l_data;
  l_temp=l_temp>>1;
  l_reg=port*0x10+GPIO_PT6+i*0x04;
  outw(l_reg,l_data);
  }

  return E_SUCCESS;
}

/*******************************************************************
*name    : DrvGPIO_LCDIOSetBit()
*function: PT6~PT13IOfXȳ]m
*input   : port: IO f 0~5 F
*          i32Bit:ݳ]mIO޸}AQ襤޸}XȴNQm1Ad0~7F
*output  : 0G\FLGѡF
*Version : v1.1
*date    : 2021-6-16
*modify  : [JPT10/PT13]m
*********************************************************************/
unsigned char DrvGPIO_LCDIOSetBit(uint32_t port,uint32_t i32Bit)
{
  unsigned int l_reg,l_data;
  unsigned char i,l_temp;
  if((port==5)||(port==6)||(port>7)||(i32Bit>7))
    return E_FAIL;
  i=i32Bit/2;
  l_temp=(1+i32Bit)%2;
  if(l_temp==1)
    l_data=(l_data&0x0)+(0x1<<LCDIO_DO)+(0x01<<LCDIO_DO_MASK);
  else
    l_data=(l_data&0x0)+(0x1<<(LCDIO_DO+16))+(0x01<<(LCDIO_DO_MASK+16));

  l_reg=port*0x10+GPIO_PT6+i*0x04;
  outw(l_reg,l_data);

  return E_SUCCESS;
}

/*******************************************************************
*name    : DrvGPIO_LCDIOClrBit()
*function: PT6~PT13IOfXȲMs
*input   : port: IO f 0~5 F
*          i32Bit:ݳ]mIO޸}AQ襤޸}XȴNQm0Ad0~7F
*output  : 0G\FLGѡF
*Version : v1.0
*date    : 2021-6-16
*modify  : [JPT10/PT13]m
*********************************************************************/
unsigned char DrvGPIO_LCDIOClrBit(uint32_t port,uint32_t i32Bit)
{
  unsigned int l_reg,l_data;
  unsigned char i,l_temp;
  l_temp=i32Bit;
  if((port==5)||(port==6)||(port>7)||(i32Bit>7))
    return E_FAIL;
  i=i32Bit/2;
  l_temp=(1+i32Bit)%2;
  if(l_temp==1)
    l_data=(l_data&0x0)+(0x0<<LCDIO_DO)+(0x01<<LCDIO_DO_MASK);
  else
    l_data=(0x0<<(LCDIO_DO+16))+(0x01<<(LCDIO_DO_MASK+16));

  l_reg=port*0x10+GPIO_PT6+i*0x04;
  outw(l_reg,l_data);

  return E_SUCCESS;
}

/*******************************************************************
*name    : DrvGPIO_LCDIOGetPorts()
*function: ŪPT6~PT13IOfJA
*input   : port: IO f 0~4 F ŪIO fJA
*output  : IOfJA
*Version : v1.1
*date    : 2021-6-16
*modify  : קfor(i=lenth;i>0;i--) l_data=(l_temp>>LCDIO_DI)&0X01+l_data;yy 2014/09/24
*          [JPT10/PT13]m
*********************************************************************/
unsigned int DrvGPIO_LCDIOGetPorts(uint32_t port)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  if((port==5)||(port==6)||(port>7))
    return 0XFF000000;
  l_data=0x00000000;
  for(i=4;i>0;i--)
  {
  l_reg=port*0x10+GPIO_PT6+(i-1)*0x04;
  l_temp=inw(l_reg);
  l_data=l_data<<1;
  l_data=((l_temp>>(LCDIO_DI+16))&0X01)+l_data;
  l_data=l_data<<1;
  l_data=((l_temp>>(LCDIO_DI))&0X01)+l_data;
  }
  return l_data&0xff;
}

/*******************************************************************
*name    : DrvGPIO_LCDIOGetBit()
*function: ŪPT6~PT13IOfJA
*input   : port: IO f 0~4 F ŪYIO fQ襤޸}JA
*          i32Bit: IO޸}AJd0~7
*output  : IOfQ襤޸}JA
*Version : v1.1
*date    : 2021-6-16
*modify  : [JPT10/PT13]m
*********************************************************************/
unsigned int DrvGPIO_LCDIOGetBit(uint32_t port,uint32_t i32Bit)
{
  unsigned int l_reg,l_data;
  unsigned char i,l_temp;
  l_temp=i32Bit;
  if((port==5)||(port==6)||(port>7)||(i32Bit>7))
    return 0xff;
  i=(i32Bit)/2;
  l_temp=(i32Bit)%2;
  l_reg=port*0x10+GPIO_PT6+i*0x04;

  if(l_temp==0)
    l_data=(inw(l_reg)>>LCDIO_DI)&0X01;
  else
    l_data=(inw(l_reg)>>(LCDIO_DI+16))&0X01;

  return l_data&0x1;
}

/*************************************************************************
name:      DrvGPIO_EnableAnalogPin
function:  qLܡAIOfpinƦrҦpJBXB~_B_ĲouFIO쬰1A~Qĳ]mC
input:     portGPT3; upin:0~0xff; (uport3 _Analog pin)
output:    0/1 success/fail
note:       uw㦳_άJHҦIO pin]mALS_ΪФn]mF
date:      2020-9-28
*************************************************************************/
unsigned char DrvGPIO_EnableAnalogPin(short port,unsigned int i32Bit)
{
  unsigned int l_reg,l_data;
  if(i32Bit>0xff)
    return E_FAIL;
  if (port==3) {l_reg=PT3_BASE;}
  else return E_FAIL;

  l_data=(i32Bit<<8)&0xff00;       //disable digital output mode
  outw(l_reg, l_data);

  l_data=(i32Bit<<24)&0xff000000;  //disable pull high mode
  outw(l_reg, l_data);

  l_reg=l_reg+OFFSET04;
  l_data=(i32Bit<<24)&0xff000000;   //disable digital input mode
  outw(l_reg, l_data);

  l_data=(i32Bit<<8)&0xff00;       //clear the output data
  outw(l_reg,l_data);

  //if(port>2) return E_SUCCESS;
  if (port==3)  {l_reg=l_reg+OFFSET04;}
  l_data=(i32Bit<<16)+(i32Bit<<24);
  l_data=inw(l_reg)|l_data;
  outw(l_reg, l_data);
  
  if (port==3)  {l_reg=INTERRUPT_BASE+OFFSET20;}
  l_data=(i32Bit<<24)&0xff000000;  //disable PT3 interrupt MODE
  outw(l_reg, l_data);

  return E_SUCCESS;
}

/*************************************************************************
name:      DrvGPIO_DisableAnalogPin
function:  qLܡAIOfpinҦ;IO쬰1A~Qĳ]mC
input:     portGPT3; upin:0~0xff; (uport3 _Analog pin)
output:    0/1 success/fail
note:       uw㦳_άJHҦIO pin]mALS_ΪФn]mF
date:      2020-09-28
*************************************************************************/
unsigned char DrvGPIO_DisableAnalogPin(short port,unsigned int i32Bit)
{
  unsigned int l_reg,l_data;
  if(i32Bit>0xff)
    return E_FAIL;
  if (port==3) {l_reg=PT3_BASE;}
  else return E_FAIL;

  l_data=(i32Bit<<16)+(i32Bit<<24);
  l_reg=l_reg+OFFSET08;
  l_data=inw(l_reg)&l_data;
  outw(l_reg, l_data);

  l_data=(i32Bit<<24)&0xff000000;  //disable interrupt MODE
  outw(l_reg, l_data);

  return E_SUCCESS;
}

//************************************************************************
//*****************  PT1 ²Ʈw  **************************************
//************************************************************************

/****************************************************************************
 * name    : DrvGPIO_PT1_EnableINPUT(short int ubit)
 * function: enable the PT1 pin input mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-09-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT1_EnableINPUT(short int ubit)
{
    uint32_t l_data;

    l_data=(ubit <<16)|(ubit <<24);
    outw(PT1_BASE+OFFSET04, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT1_DisableINPUT(short int ubit)
 * function: disable the PT1 pin input mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT1_DisableINPUT(short int ubit)
{
    uint32_t l_data;

    l_data=(ubit<<24)&0xff000000;
    outw(PT1_BASE+OFFSET04, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT1_EnablePullHigh(short int ubit)
 * function: enable the PT1 pin pull high mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT1_EnablePullHigh(short int ubit)
{
    uint32_t l_data;

    l_data=(ubit <<16)|(ubit <<24);
    outw(PT1_BASE, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT1_DisablePullHigh(short int ubit)
 * function: disable the PT1 pin PullHigh mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT1_DisablePullHigh(short int ubit)
{
    uint32_t l_data;

    l_data=(ubit<<24)&0xff000000;
    outw(PT1_BASE, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT1_EnableOUTPUT(short int ubit)
 * function: enable the PT1 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT1_EnableOUTPUT(short int ubit)
{
  uint32_t l_data;

    l_data=(ubit<<8)|ubit;
    outw(PT1_BASE, l_data);
}
/****************************************************************************
 * name    : DrvGPIO_PT1_DisableOUTPUT(short int ubit)
 * function: disable the PT1 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT1_DisableOUTPUT(short int ubit)
{
  uint32_t l_data;

  l_data=(ubit<<8)&0xff00;
    outw(PT1_BASE, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT1_EnableINT(short int ubit)
 * function: enable the PT1 pin EXTERNAL INTERRUPT mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT1_EnableINT(short int ubit)
{
    uint32_t l_data;

  l_data=(ubit<<16)+(ubit<<24);
  //l_reg=INTERRUPT_BASE+OFFSET10;
  outw(INTERRUPT_BASE+OFFSET10, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT1_DisableINT(short int ubit)
 * function: disable the PT1 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT1_DisableINT(short int ubit)
{
    uint32_t l_data;

  l_data=(ubit<<24)&0xff000000;
  //l_reg=INTERRUPT_BASE+OFFSET10;
  outw(INTERRUPT_BASE+OFFSET10, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT1_IntTriggerPorts(uint32_t i32Bit, uint32_t mode)
 * function: setting PT1 interrupt trig edge
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT1_IntTriggerPorts(uint32_t i32Bit, uint32_t mode)
{
    uint32_t l_reg,l_data;

    l_reg=PT1_BASE+OFFSET0C;
    l_data=inw(l_reg)|(i32Bit<<24);
    if (i32Bit&(1<<0)) {l_data=(l_data&0xfffffff8)+mode;}
    if (i32Bit&(1<<1)) {l_data=(l_data&0xffffffc7)+(mode<<3);}
    if (i32Bit&(1<<2)) {l_data=(l_data&0xfffffe3f)+(mode<<6);}
    if (i32Bit&(1<<3)) {l_data=(l_data&0xfffff1ff)+(mode<<9);}
    if (i32Bit&(1<<4)) {l_data=(l_data&0xffff8fff)+(mode<<12);}
    if (i32Bit&(1<<5)) {l_data=(l_data&0xfffc7fff)+(mode<<15);}
    if (i32Bit&(1<<6)) {l_data=(l_data&0xffe3ffff)+(mode<<18);}
    if (i32Bit&(1<<7)) {l_data=(l_data&0xff1fffff)+(mode<<21);}
    outw(l_reg, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT1_IntTriggerBit(uint32_t i32Bit, uint32_t mode)
 * function: setting PT1 interrupt trig edge
 * input   : ubit:0~7,wbit~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT1_IntTriggerBit(uint32_t i32Bit, uint32_t mode)
{
  uint32_t l_data;

    //l_reg=PT1_BASE+OFFSET0C;
    l_data=inw(PT1_BASE+OFFSET0C)|(1<<(24+i32Bit));
    l_data=(~(0x7<<(i32Bit*3))&l_data)|(mode<<(i32Bit*3));
     outw(PT1_BASE+OFFSET0C, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT1_ClearIntFlag(short int ubit)
 * function: Clear PT1 Interrupt Flag
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT1_ClearIntFlag(short int uint32)
{
  unsigned int l_data;
  l_data=(uint32<<8);
  //l_reg=GPIO_INTERRUPT_CTRL;
  outw(GPIO_INTERRUPT_CTRL,l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT1_GetIntFlag(void)
 * function: read PT1 Interrupt Flag
 * input   : NO
 * output  : ^_лx
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
unsigned char DrvGPIO_PT1_GetIntFlag(void)
{
  return (inw(GPIO_INTERRUPT_CTRL)&0xff);
}

/****************************************************************************
 * name    : DrvGPIO_PT1_GetPortBits (void)
 * function: read PT1 JA
 * input   : NO
 * output  : ^PT1 PORT JA
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
unsigned char DrvGPIO_PT1_GetPortBits (void)
{
  return inw(PT1_BASE+OFFSET08)&0x000000ff;
}

/****************************************************************************
 * name    : DrvGPIO_PT1_SetPortBits (unsigned char ui32Data)
 * function: setting PT1 }X1
 * input   : ui32Data:0~0xff,쬰1A~Qĳ]mX1F
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT1_SetPortBits (unsigned char ui32Data)
{
  unsigned int l_data;

  //l_reg=PT1_BASE+OFFSET04;
  l_data=ui32Data|(ui32Data<<8);
  outw(PT1_BASE+OFFSET04, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT1_ClrPortBits (unsigned int ui32Data)
 * function: setting PT1 }X0
 * input   : ui32Data:0~0xff,쬰1A~Qĳ]mX0F
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT1_ClrPortBits (unsigned int ui32Data)
{
  //unsigned int l_reg,l_data;

  //l_reg=PT1_BASE+OFFSET04;
  outw(PT1_BASE+OFFSET04, ui32Data<<8);
}

//******************  PT2²Ʈw  ******************************************
//******************  PT2 simple FUNCTION FOR REDUCE CODE SIZE *****************
//******************************************************************************
//******************************************************************************

/****************************************************************************
 * name    : DrvGPIO_PT2_EnableINPUT(short int ubit)
 * function: enable the PT2 pin input mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT2_EnableINPUT(short int ubit)
{
    uint32_t l_data;

    l_data=(ubit <<16)|(ubit <<24);
    outw(PT2_BASE+OFFSET04, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT2_DisableINPUT(short int ubit)
 * function: disable the PT2 pin input mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT2_DisableINPUT(short int ubit)
{
    uint32_t l_data;

    l_data=(ubit<<24)&0xff000000;
    outw(PT2_BASE+OFFSET04, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT2_EnablePullHigh(short int ubit)
 * function: enable the PT2 pin pull high mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT2_EnablePullHigh(short int ubit)
{
    uint32_t l_data;

    l_data=(ubit <<16)|(ubit <<24);
    outw(PT2_BASE, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT2_DisablePullHigh(short int ubit)
 * function: disable the PT2 pin PullHigh mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT2_DisablePullHigh(short int ubit)
{
    uint32_t l_data;

    l_data=(ubit<<24)&0xff000000;
    outw(PT2_BASE, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT2_EnableOUTPUT(short int ubit)
 * function: enable the PT2 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT2_EnableOUTPUT(short int ubit)
{
  uint32_t l_data;

    l_data=(ubit<<8)|ubit;
    outw(PT2_BASE, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT2_DisableOUTPUT(short int ubit)
 * function: disable the PT2 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT2_DisableOUTPUT(short int ubit)
{
  uint32_t l_data;

  l_data=(ubit<<8)&0xff00;
  outw(PT2_BASE, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT2_EnableINT(short int ubit)
 * function: enable the PT2 pin EXTERNAL INTERRUPT mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT2_EnableINT(short int ubit)
{
  uint32_t l_data;

  l_data=(ubit<<16)+(ubit<<24);
  //l_reg=INTERRUPT_BASE+OFFSET14;
  outw(INTERRUPT_BASE+OFFSET14, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT2_DisableINT(short int ubit)
 * function: disable the PT2 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT2_DisableINT(short int ubit)
{
  uint32_t l_data;

  l_data=(ubit<<24)&0xff000000;
  //l_reg=INTERRUPT_BASE+OFFSET14;
  outw(INTERRUPT_BASE+OFFSET14, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT2_IntTriggerPorts(uint32_t i32Bit, uint32_t mode)
 * function: setting PT2 interrupt trig edge
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT2_IntTriggerPorts(uint32_t i32Bit, uint32_t mode)
{
  uint32_t l_reg,l_data;

    l_reg=PT2_BASE+OFFSET0C;
    l_data=inw(l_reg)|(i32Bit<<24);
    if (i32Bit&(1<<0)) {l_data=(l_data&0xfffffff8)+mode;}
    if (i32Bit&(1<<1)) {l_data=(l_data&0xffffffc7)+(mode<<3);}
    if (i32Bit&(1<<2)) {l_data=(l_data&0xfffffe3f)+(mode<<6);}
    if (i32Bit&(1<<3)) {l_data=(l_data&0xfffff1ff)+(mode<<9);}
    if (i32Bit&(1<<4)) {l_data=(l_data&0xffff8fff)+(mode<<12);}
    if (i32Bit&(1<<5)) {l_data=(l_data&0xfffc7fff)+(mode<<15);}
    if (i32Bit&(1<<6)) {l_data=(l_data&0xffe3ffff)+(mode<<18);}
    if (i32Bit&(1<<7)) {l_data=(l_data&0xff1fffff)+(mode<<21);}
     outw(l_reg, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT2_IntTriggerBit(uint32_t i32Bit, uint32_t mode)
 * function: setting PT2 interrupt trig edge
 * input   : ubit:0~7,wbit~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT2_IntTriggerBit(uint32_t i32Bit, uint32_t mode)
{
  uint32_t l_data;

    //l_reg=PT2_BASE+OFFSET0C;
    l_data=inw(PT2_BASE+OFFSET0C)|(1<<(24+i32Bit));
    l_data=(~(0x7<<(i32Bit*3))&l_data)|(mode<<(i32Bit*3));
     outw(PT2_BASE+OFFSET0C, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT2_ClearIntFlag(short int ubit)
 * function: Clear PT2 Interrupt Flag
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT2_ClearIntFlag(short int uint32)
{
  unsigned int l_data;
  l_data=(uint32<<8);
  //l_reg=GPIO_INTERRUPT_CTRL+OFFSET04;
  outw(GPIO_INTERRUPT_CTRL+OFFSET04,l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT2_GetIntFlag(void)
 * function: read PT2 Interrupt Flag
 * input   : NO
 * output  : ^_лx
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
unsigned char DrvGPIO_PT2_GetIntFlag(void)
{
  return (inw(GPIO_INTERRUPT_CTRL+OFFSET04)&0xff);
}

/****************************************************************************
 * name    : DrvGPIO_PT2_GetPortBits (void)
 * function: read PT2 JA
 * input   : NO
 * output  : ^PT2 PORT JA
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
unsigned char DrvGPIO_PT2_GetPortBits (void)
{
  return inw(PT2_BASE+OFFSET08)&0x000000ff;
}

/****************************************************************************
 * name    : DrvGPIO_PT2_SetPortBits (unsigned char ui32Data)
 * function: setting PT2 }X1
 * input   : ui32Data:0~0xff,쬰1A~Qĳ]mX1F
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT2_SetPortBits (unsigned char ui32Data)
{
  unsigned int l_data;

  //l_reg=PT2_BASE+OFFSET04;
  l_data=ui32Data|(ui32Data<<8);
  outw(PT2_BASE+OFFSET04, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT2_ClrPortBits (unsigned int ui32Data)
 * function: setting PT2 }X0
 * input   : ui32Data:0~0xff,쬰1A~Qĳ]mX0F
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT2_ClrPortBits (unsigned int ui32Data)
{
  //unsigned int l_reg,l_data;

  //l_reg=PT2_BASE+OFFSET04;
  outw(PT2_BASE+OFFSET04, ui32Data<<8);
}

//******************************************************************************
//******************************************************************************
//******************  PT3 simple FUNCTION FOR REDUCE CODE SIZE *****************
//******************************************************************************
//******************************************************************************

/****************************************************************************
 * name    : DrvGPIO_PT3_EnableINPUT(short int ubit)
 * function: enable the PT3 pin input mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT3_EnableINPUT(short int ubit)
{
    uint32_t l_data;

    l_data=(ubit <<16)|(ubit <<24);
    outw(PT3_BASE+OFFSET04, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT3_DisableINPUT(short int ubit)
 * function: disable the PT3 pin input mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT3_DisableINPUT(short int ubit)
{
    uint32_t l_data;

    l_data=(ubit<<24)&0xff000000;
    outw(PT3_BASE+OFFSET04, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT3_EnablePullHigh(short int ubit)
 * function: enable the PT3 pin pull high mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT3_EnablePullHigh(short int ubit)
{
    uint32_t l_data;

    l_data=(ubit <<16)|(ubit <<24);
    outw(PT3_BASE, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT3_DisablePullHigh(short int ubit)
 * function: disable the PT3 pin PullHigh mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT3_DisablePullHigh(short int ubit)
{
    uint32_t l_data;

    l_data=(ubit<<24)&0xff000000;
    outw(PT3_BASE, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT3_EnableOUTPUT(short int ubit)
 * function: enable the PT3 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT3_EnableOUTPUT(short int ubit)
{
  uint32_t l_data;

    l_data=(ubit<<8)|ubit;
    outw(PT3_BASE, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT3_DisableOUTPUT(short int ubit)
 * function: disable the PT3 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT3_DisableOUTPUT(short int ubit)
{
  uint32_t l_data;

  l_data=(ubit<<8)&0xff00;
  outw(PT3_BASE, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT3_EnableINT(short int ubit)
 * function: enable the PT3 pin EXTERNAL INTERRUPT mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2021-6-16
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT3_EnableINT(short int ubit)
{
  uint32_t l_data;

  l_data=(ubit<<16)+(ubit<<24);
  outw(INTERRUPT_BASE+OFFSET20, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT3_DisableINT(short int ubit)
 * function: disable the PT3 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2021-6-16
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT3_DisableINT(short int ubit)
{
  uint32_t l_data;

  l_data=(ubit<<24)&0xff000000;
  outw(INTERRUPT_BASE+OFFSET20, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT3_IntTriggerPorts(uint32_t i32Bit, uint32_t mode)
 * function: setting PT3 interrupt trig edge
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2021-6-16
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT3_IntTriggerPorts(uint32_t i32Bit, uint32_t mode)
{
  uint32_t l_reg,l_data;

    l_reg=PT3_BASE+OFFSET0C;
    l_data=inw(l_reg)|(i32Bit<<24);
    if (i32Bit&(1<<0)) {l_data=(l_data&0xfffffff8)+mode;}
    if (i32Bit&(1<<1)) {l_data=(l_data&0xffffffc7)+(mode<<3);}
    if (i32Bit&(1<<2)) {l_data=(l_data&0xfffffe3f)+(mode<<6);}
    if (i32Bit&(1<<3)) {l_data=(l_data&0xfffff1ff)+(mode<<9);}
    if (i32Bit&(1<<4)) {l_data=(l_data&0xffff8fff)+(mode<<12);}
    if (i32Bit&(1<<5)) {l_data=(l_data&0xfffc7fff)+(mode<<15);}
    if (i32Bit&(1<<6)) {l_data=(l_data&0xffe3ffff)+(mode<<18);}
    if (i32Bit&(1<<7)) {l_data=(l_data&0xff1fffff)+(mode<<21);}
     outw(l_reg, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT3_IntTriggerBit(uint32_t i32Bit, uint32_t mode)
 * function: setting PT3 interrupt trig edge
 * input   : ubit:0~7,wbit~Qĳ]m
 * output  : NO
 * date    : 2021-6-16
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT3_IntTriggerBit(uint32_t i32Bit, uint32_t mode)
{
  uint32_t l_data;

    l_data=inw(PT3_BASE+OFFSET0C)|(1<<(24+i32Bit));
    l_data=(~(0x7<<(i32Bit*3))&l_data)|(mode<<(i32Bit*3));
    outw(PT3_BASE+OFFSET0C, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT3_ClearIntFlag(short int ubit)
 * function: Clear PT3 Interrupt Flag
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2021-6-16
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT3_ClearIntFlag(short int uint32)
{
  unsigned int l_data;
  l_data=(uint32<<8);
  outw(INTERRUPT_BASE+OFFSET10,l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT3_GetIntFlag(void)
 * function: read PT3 Interrupt Flag
 * input   : NO
 * output  : ^_лx
 * date    : 2021-6-16
 * modify  : no
 ****************************************************************************/
unsigned char DrvGPIO_PT3_GetIntFlag(void)
{
  return (inw(INTERRUPT_BASE+OFFSET10)&0xff);
}

/****************************************************************************
 * name    : DrvGPIO_PT3_GetPortBits (void)
 * function: read PT3 JA
 * input   : NO
 * output  : ^PT3 PORT JA
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
unsigned char DrvGPIO_PT3_GetPortBits (void)
{
  return inw(PT3_BASE+OFFSET08)&0x000000ff;
}

/****************************************************************************
 * name    : DrvGPIO_PT3_SetPortBits (unsigned char ui32Data)
 * function: setting PT3 }X1
 * input   : ui32Data:0~0xff,쬰1A~Qĳ]mX1F
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT3_SetPortBits (unsigned char ui32Data)
{
  unsigned int l_data;

  //l_reg=PT3_BASE+OFFSET04;
  l_data=ui32Data|(ui32Data<<8);
  outw(PT3_BASE+OFFSET04, l_data);
}

/****************************************************************************
 * name    : DrvGPIO_PT3_ClrPortBits (unsigned int ui32Data)
 * function: setting PT3 }X0
 * input   : ui32Data:0~0xff,쬰1A~Qĳ]mX0F
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT3_ClrPortBits (unsigned int ui32Data)
{
  //unsigned int l_reg,l_data;

  //l_reg=PT1_BASE+OFFSET04;
  outw(PT3_BASE+OFFSET04, ui32Data<<8);
}

//**************************************************************************
//****************  HY16F19X PT6 IO  ***************************************
//**************************************************************************
/****************************************************************************
 * name    : DrvGPIO_PT6_EnableINPUT(short int ubit)
 * function: enable the PT6 pin input mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT6_EnableINPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+((l_temp&0x1)<<LCDIO_IN)+((l_temp&0x01)<<LCDIO_IN_MASK);
    l_temp=l_temp>>1;
    l_data=((l_temp&0x1)<<(LCDIO_IN+16))+((l_temp&0x01)<<(LCDIO_IN_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT6+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT6_DisableINPUT(short int ubit)
 * function: disable the PT6 pin input mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT6_DisableINPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_IN)+((l_temp&0x01)<<LCDIO_IN_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_IN+16))+((l_temp&0x01)<<(LCDIO_IN_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT6+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT6_EnableOUTPUT(short int ubit)
 * function: enable the PT6 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT6_EnableOUTPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+((l_temp&0x1)<<LCDIO_OUT)+((l_temp&0x01)<<LCDIO_OUT_MASK);
    l_temp=l_temp>>1;
    l_data=((l_temp&0x1)<<(LCDIO_OUT+16))+((l_temp&0x01)<<(LCDIO_OUT_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT6+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT6_DisableOUTPUT(short int ubit)
 * function: disable the PT6 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT6_DisableOUTPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ubit;

  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_OUT)+((l_temp&0x01)<<LCDIO_OUT_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_OUT+16))+((l_temp&0x01)<<(LCDIO_OUT_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT6+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT6_GetPortBits (void)
 * function: read PT6 JA
 * input   : NO
 * output  : ^PT6 PORT JA
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
unsigned char DrvGPIO_PT6_GetPortBits (void)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_data=0x00000000;
  for(i=4;i>0;i--)
  {
  l_reg=GPIO_PT6+(i-1)*0x04;
  l_temp=inw(l_reg);
  l_data=l_data<<1;
  l_data=((l_temp>>(LCDIO_DI+16))&0X01)+l_data;
  l_data=l_data<<1;
  l_data=((l_temp>>(LCDIO_DI))&0X01)+l_data;
  }
  return l_data&0xff;
}

/****************************************************************************
 * name    : DrvGPIO_PT6_SetPortBits (unsigned char ui32Data)
 * function: setting PT6 }X1
 * input   : ui32Data:0~0xff,쬰1A~Qĳ]mX1F
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT6_SetPortBits (unsigned char ui32Data)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ui32Data;

  for(i=0;i<4;i++)
  {
  l_data=(l_data&0x0)+(0x01<<LCDIO_DO)+((l_temp&0x1)<<LCDIO_DO_MASK);
  l_temp=l_temp>>1;
  l_data=(0x01<<(LCDIO_DO+16))+((l_temp&0x1)<<(LCDIO_DO_MASK+16))+l_data;
  l_temp=l_temp>>1;
  l_reg=GPIO_PT6+i*0x04;
  outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT6_ClrPortBits (unsigned int ui32Data)
 * function: setting PT6 }X0
 * input   : ui32Data:0~0xff,쬰1A~Qĳ]mX0F
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT6_ClrPortBits (unsigned int ui32Data)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ui32Data;

  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_DO)+((l_temp&0x1)<<LCDIO_DO_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_DO+16))+((l_temp&0x1)<<(LCDIO_DO_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT6+i*0x04;
    outw(l_reg,l_data);
  }
}

//*******************************************************************************
/********************************************************************************
 ******************** PT7 IO function *******************************************
 ********************************************************************************/
/****************************************************************************
 * name    : DrvGPIO_PT7_EnableINPUT(short int ubit)
 * function: enable the PT7 pin input mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT7_EnableINPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+((l_temp&0x1)<<LCDIO_IN)+((l_temp&0x01)<<LCDIO_IN_MASK);
    l_temp=l_temp>>1;
    l_data=((l_temp&0x1)<<(LCDIO_IN+16))+((l_temp&0x01)<<(LCDIO_IN_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT7+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT7_DisableINPUT(short int ubit)
 * function: disable the PT7 pin input mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT7_DisableINPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_IN)+((l_temp&0x01)<<LCDIO_IN_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_IN+16))+((l_temp&0x01)<<(LCDIO_IN_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT7+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT7_EnableOUTPUT(short int ubit)
 * function: enable the PT7 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT7_EnableOUTPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+((l_temp&0x1)<<LCDIO_OUT)+((l_temp&0x01)<<LCDIO_OUT_MASK);
    l_temp=l_temp>>1;
    l_data=((l_temp&0x1)<<(LCDIO_OUT+16))+((l_temp&0x01)<<(LCDIO_OUT_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT7+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT7_DisableOUTPUT(short int ubit)
 * function: disable the PT7 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT7_DisableOUTPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ubit;

  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_OUT)+((l_temp&0x01)<<LCDIO_OUT_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_OUT+16))+((l_temp&0x01)<<(LCDIO_OUT_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT7+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT7_GetPortBits (void)
 * function: read PT7 JA
 * input   : NO
 * output  : ^PT3 PORT JA
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
unsigned char DrvGPIO_PT7_GetPortBits (void)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_data=0x00000000;
  for(i=4;i>0;i--)
  {
  l_reg=GPIO_PT7+(i-1)*0x04;
  l_temp=inw(l_reg);
  l_data=l_data<<1;
  l_data=((l_temp>>(LCDIO_DI+16))&0X01)+l_data;
  l_data=l_data<<1;
  l_data=((l_temp>>(LCDIO_DI))&0X01)+l_data;
  }
  return l_data&0xff;
}

/****************************************************************************
 * name    : DrvGPIO_PT7_SetPortBits (unsigned char ui32Data)
 * function: setting PT7 }X1
 * input   : ui32Data:0~0xff,쬰1A~Qĳ]mX1F
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT7_SetPortBits (unsigned char ui32Data)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ui32Data;

  for(i=0;i<4;i++)
  {
  l_data=(l_data&0x0)+(0x01<<LCDIO_DO)+((l_temp&0x1)<<LCDIO_DO_MASK);
  l_temp=l_temp>>1;
  l_data=(0x01<<(LCDIO_DO+16))+((l_temp&0x1)<<(LCDIO_DO_MASK+16))+l_data;
  l_temp=l_temp>>1;
  l_reg=GPIO_PT7+i*0x04;
  outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT7_ClrPortBits (unsigned int ui32Data)
 * function: setting PT7 }X0
 * input   : ui32Data:0~0xff,쬰1A~Qĳ]mX0F
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT7_ClrPortBits (unsigned int ui32Data)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ui32Data;

  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_DO)+((l_temp&0x1)<<LCDIO_DO_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_DO+16))+((l_temp&0x1)<<(LCDIO_DO_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT7+i*0x04;
    outw(l_reg,l_data);
  }
}

//***************************************************************************
/****************************************************************************
 ************************    PT8 IO function    *****************************
 ****************************************************************************/
/****************************************************************************
 * name    : DrvGPIO_PT8_EnableINPUT(short int ubit)
 * function: enable the PT8 pin input mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT8_EnableINPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+((l_temp&0x1)<<LCDIO_IN)+((l_temp&0x01)<<LCDIO_IN_MASK);
    l_temp=l_temp>>1;
    l_data=((l_temp&0x1)<<(LCDIO_IN+16))+((l_temp&0x01)<<(LCDIO_IN_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT8+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT8_DisableINPUT(short int ubit)
 * function: disable the PT8 pin input mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT8_DisableINPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_IN)+((l_temp&0x01)<<LCDIO_IN_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_IN+16))+((l_temp&0x01)<<(LCDIO_IN_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT8+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT8_EnableOUTPUT(short int ubit)
 * function: enable the PT8 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT8_EnableOUTPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+((l_temp&0x1)<<LCDIO_OUT)+((l_temp&0x01)<<LCDIO_OUT_MASK);
    l_temp=l_temp>>1;
    l_data=((l_temp&0x1)<<(LCDIO_OUT+16))+((l_temp&0x01)<<(LCDIO_OUT_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT8+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT8_DisableOUTPUT(short int ubit)
 * function: disable the PT8 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT8_DisableOUTPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ubit;

  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_OUT)+((l_temp&0x01)<<LCDIO_OUT_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_OUT+16))+((l_temp&0x01)<<(LCDIO_OUT_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT8+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT8_GetPortBits (void)
 * function: read PT8 JA
 * input   : NO
 * output  : ^PT3 PORT JA
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
unsigned char DrvGPIO_PT8_GetPortBits (void)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_data=0x00000000;
  for(i=4;i>0;i--)
  {
  l_reg=GPIO_PT8+(i-1)*0x04;
  l_temp=inw(l_reg);
  l_data=l_data<<1;
  l_data=((l_temp>>(LCDIO_DI+16))&0X01)+l_data;
  l_data=l_data<<1;
  l_data=((l_temp>>(LCDIO_DI))&0X01)+l_data;
  }
  return l_data&0xff;
}

/****************************************************************************
 * name    : DrvGPIO_PT8_SetPortBits (unsigned char ui32Data)
 * function: setting PT8 }X1
 * input   : ui32Data:0~0xff,쬰1A~Qĳ]mX1F
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT8_SetPortBits (unsigned char ui32Data)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ui32Data;

  for(i=0;i<4;i++)
  {
  l_data=(l_data&0x0)+(0x01<<LCDIO_DO)+((l_temp&0x1)<<LCDIO_DO_MASK);
  l_temp=l_temp>>1;
  l_data=(0x01<<(LCDIO_DO+16))+((l_temp&0x1)<<(LCDIO_DO_MASK+16))+l_data;
  l_temp=l_temp>>1;
  l_reg=GPIO_PT8+i*0x04;
  outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT8_ClrPortBits (unsigned int ui32Data)
 * function: setting PT8 }X0
 * input   : ui32Data:0~0xff,쬰1A~Qĳ]mX0F
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT8_ClrPortBits (unsigned int ui32Data)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ui32Data;

  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_DO)+((l_temp&0x1)<<LCDIO_DO_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_DO+16))+((l_temp&0x1)<<(LCDIO_DO_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT8+i*0x04;
    outw(l_reg,l_data);
  }
}

//****************************************************************************
/*****************************************************************************
 ****************************  PT9 IO function     ****************************
 *****************************************************************************/
/****************************************************************************
 * name    : DrvGPIO_PT9_EnableINPUT(short int ubit)
 * function: enable the PT9 pin input mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT9_EnableINPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+((l_temp&0x1)<<LCDIO_IN)+((l_temp&0x01)<<LCDIO_IN_MASK);
    l_temp=l_temp>>1;
    l_data=((l_temp&0x1)<<(LCDIO_IN+16))+((l_temp&0x01)<<(LCDIO_IN_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT9+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT9_DisableINPUT(short int ubit)
 * function: disable the PT9 pin input mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT9_DisableINPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_IN)+((l_temp&0x01)<<LCDIO_IN_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_IN+16))+((l_temp&0x01)<<(LCDIO_IN_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT9+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT9_EnableOUTPUT(short int ubit)
 * function: enable the PT9 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT9_EnableOUTPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+((l_temp&0x1)<<LCDIO_OUT)+((l_temp&0x01)<<LCDIO_OUT_MASK);
    l_temp=l_temp>>1;
    l_data=((l_temp&0x1)<<(LCDIO_OUT+16))+((l_temp&0x01)<<(LCDIO_OUT_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT9+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT9_DisableOUTPUT(short int ubit)
 * function: disable the PT9 pin output mode
 * input   : ubit:0~0xff,bit1A~Qĳ]m
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT9_DisableOUTPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ubit;

  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_OUT)+((l_temp&0x01)<<LCDIO_OUT_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_OUT+16))+((l_temp&0x01)<<(LCDIO_OUT_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT9+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT9_GetPortBits (void)
 * function: read PT9 JA
 * input   : NO
 * output  : ^PT3 PORT JA
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
unsigned char DrvGPIO_PT9_GetPortBits (void)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_data=0x00000000;
  for(i=4;i>0;i--)
  {
  l_reg=GPIO_PT9+(i-1)*0x04;
  l_temp=inw(l_reg);
  l_data=l_data<<1;
  l_data=((l_temp>>(LCDIO_DI+16))&0X01)+l_data;
  l_data=l_data<<1;
  l_data=((l_temp>>(LCDIO_DI))&0X01)+l_data;
  }
  return l_data&0xff;
}

/****************************************************************************
 * name    : DrvGPIO_PT9_SetPortBits (unsigned char ui32Data)
 * function: setting PT9 }X1
 * input   : ui32Data:0~0xff,쬰1A~Qĳ]mX1F
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT9_SetPortBits (unsigned char ui32Data)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ui32Data;

  for(i=0;i<4;i++)
  {
  l_data=(l_data&0x0)+(0x01<<LCDIO_DO)+((l_temp&0x1)<<LCDIO_DO_MASK);
  l_temp=l_temp>>1;
  l_data=(0x01<<(LCDIO_DO+16))+((l_temp&0x1)<<(LCDIO_DO_MASK+16))+l_data;
  l_temp=l_temp>>1;
  l_reg=GPIO_PT9+i*0x04;
  outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT9_ClrPortBits (unsigned int ui32Data)
 * function: setting PT9 }X0
 * input   : ui32Data:0~0xff,쬰1A~Qĳ]mX0F
 * output  : NO
 * date    : 2020-9-28
 * modify  : no
 ****************************************************************************/
void DrvGPIO_PT9_ClrPortBits (unsigned int ui32Data)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ui32Data;

  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_DO)+((l_temp&0x1)<<LCDIO_DO_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_DO+16))+((l_temp&0x1)<<(LCDIO_DO_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT9+i*0x04;
    outw(l_reg,l_data);
  }
}

/*****************************************************************************
 **************************** PT10 IO function    ****************************
 *****************************************************************************/

/****************************************************************************
 * name    : DrvGPIO_PT10_EnableINPUT(short int ubit)
 * function: enable the PT10 pin input mode
 * input   : ubit:0~0x03,bit1A~Qĳ]m
 * output  : NO
 * date    : 2021-6-16
 * modify  : ץPT10.1~10.7]m
 ****************************************************************************/
void DrvGPIO_PT10_EnableINPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+((l_temp&0x1)<<LCDIO_IN)+((l_temp&0x01)<<LCDIO_IN_MASK);
    l_temp=l_temp>>1;
    l_data=((l_temp&0x1)<<(LCDIO_IN+16))+((l_temp&0x01)<<(LCDIO_IN_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT10+i*0x04;
    outw(l_reg,l_data);
  }
} 

/****************************************************************************
 * name    : DrvGPIO_PT10_DisableINPUT(short int ubit)
 * function: disable the PT10 pin input mode
 * input   : ubit:0~0x03,bit1A~Qĳ]m
 * output  : NO
 * date    : 2021-6-16
 * modify  : ץPT10.1~10.7]m
 ****************************************************************************/
void DrvGPIO_PT10_DisableINPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_IN)+((l_temp&0x01)<<LCDIO_IN_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_IN+16))+((l_temp&0x01)<<(LCDIO_IN_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT10+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT10_EnableOUTPUT(short int ubit)
 * function: enable the PT10 pin output mode
 * input   : ubit:0~0x03,bit1A~Qĳ]m
 * output  : NO
 * date    : 2021-6-16
 * modify  : ץPT10.1~10.7]m
 ****************************************************************************/
void DrvGPIO_PT10_EnableOUTPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+((l_temp&0x1)<<LCDIO_OUT)+((l_temp&0x01)<<LCDIO_OUT_MASK);
    l_temp=l_temp>>1;
    l_data=((l_temp&0x1)<<(LCDIO_OUT+16))+((l_temp&0x01)<<(LCDIO_OUT_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT10+i*0x04;
    outw(l_reg,l_data);
  }
}
/****************************************************************************
 * name    : DrvGPIO_PT10_DisableOUTPUT(short int ubit)
 * function: disable the PT10 pin output mode
 * input   : ubit:0~0x03,bit1A~Qĳ]m
 * output  : NO
 * date    : 2021-6-16
 * modify  : ץPT10.1~10.7]m
 ****************************************************************************/
void DrvGPIO_PT10_DisableOUTPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ubit;

  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_OUT)+((l_temp&0x01)<<LCDIO_OUT_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_OUT+16))+((l_temp&0x01)<<(LCDIO_OUT_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT10+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT10_GetPortBits (void)
 * function: read PT10 JA
 * input   : NO
 * output  : ^PT10 PORT JA
 * date    : 2021-6-16
 * modify  : ץPT10.1~10.7]m
 ****************************************************************************/
unsigned char DrvGPIO_PT10_GetPortBits (void)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_data=0x00000000;
  for(i=4;i>0;i--)
  {
  l_reg=GPIO_PT10+(i-1)*0x04;
  l_temp=inw(l_reg);
  l_data=l_data<<1;
  l_data=((l_temp>>(LCDIO_DI+16))&0X01)+l_data;
  l_data=l_data<<1;
  l_data=((l_temp>>(LCDIO_DI))&0X01)+l_data;
  }
  return l_data&0xff;
}

/****************************************************************************
 * name    : DrvGPIO_PT10_SetPortBits (unsigned char ui32Data)
 * function: setting PT10 }X1
 * input   : ui32Data:0~0x03,쬰1A~Qĳ]mX1F
 * output  : NO
 * date    : 2021-6-16
 * modify  : ץPT10.1~10.7]m
 ****************************************************************************/
void DrvGPIO_PT10_SetPortBits (unsigned char ui32Data)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ui32Data;

  for(i=0;i<4;i++)
  {
  l_data=(l_data&0x0)+(0x01<<LCDIO_DO)+((l_temp&0x1)<<LCDIO_DO_MASK);
  l_temp=l_temp>>1;
  l_data=(0x01<<(LCDIO_DO+16))+((l_temp&0x1)<<(LCDIO_DO_MASK+16))+l_data;
  l_temp=l_temp>>1;
  l_reg=GPIO_PT10+i*0x04;
  outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT10_ClrPortBits (unsigned int ui32Data)
 * function: setting PT10 }X0
 * input   : ui32Data:0~0x03,쬰1A~Qĳ]mX0F
 * output  : NO
 * date    : 2021-6-16
 * modify  : ץPT10.1~10.7]m
 ****************************************************************************/
void DrvGPIO_PT10_ClrPortBits (unsigned int ui32Data)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ui32Data;

  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_DO)+((l_temp&0x1)<<LCDIO_DO_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_DO+16))+((l_temp&0x1)<<(LCDIO_DO_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT10+i*0x04;
    outw(l_reg,l_data);
  }
}

/*****************************************************************************
 *****************************************************************************
 **************************** PT13 IO function    ****************************
 *****************************************************************************
 *****************************************************************************/

/****************************************************************************
 * name    : DrvGPIO_PT13_EnableINPUT(short int ubit)
 * function: enable the PT13 pin input mode
 * input   : ubit:0~0x03,bit1A~Qĳ]m
 * output  : NO
 * date    : 2021-6-16
 * modify  : ץPT13.1~13.7]m
 ****************************************************************************/
void DrvGPIO_PT13_EnableINPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+((l_temp&0x1)<<LCDIO_IN)+((l_temp&0x01)<<LCDIO_IN_MASK);
    l_temp=l_temp>>1;
    l_data=((l_temp&0x1)<<(LCDIO_IN+16))+((l_temp&0x01)<<(LCDIO_IN_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT13+i*0x04;
    outw(l_reg,l_data);
  }
} 

/****************************************************************************
 * name    : DrvGPIO_PT13_DisableINPUT(short int ubit)
 * function: disable the PT13 pin input mode
 * input   : ubit:0~0x03,bit1A~Qĳ]m
 * output  : NO
 * date    : 2021-6-16
 * modify  : ץPT13.1~13.7]m
 ****************************************************************************/
void DrvGPIO_PT13_DisableINPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_IN)+((l_temp&0x01)<<LCDIO_IN_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_IN+16))+((l_temp&0x01)<<(LCDIO_IN_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT13+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT13_EnableOUTPUT(short int ubit)
 * function: enable the PT13 pin output mode
 * input   : ubit:0~0x03,bit1A~Qĳ]m
 * output  : NO
 * date    : 2021-6-16
 * modify  : ץPT13.1~13.7]m
 ****************************************************************************/
void DrvGPIO_PT13_EnableOUTPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;
  l_temp=ubit;
  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+((l_temp&0x1)<<LCDIO_OUT)+((l_temp&0x01)<<LCDIO_OUT_MASK);
    l_temp=l_temp>>1;
    l_data=((l_temp&0x1)<<(LCDIO_OUT+16))+((l_temp&0x01)<<(LCDIO_OUT_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT13+i*0x04;
    outw(l_reg,l_data);
  }
}
/****************************************************************************
 * name    : DrvGPIO_PT13_DisableOUTPUT(short int ubit)
 * function: disable the PT13 pin output mode
 * input   : ubit:0~0x03,bit1A~Qĳ]m
 * output  : NO
 * date    : 2021-6-16
 * modify  : ץPT13.1~13.7]m
 ****************************************************************************/
void DrvGPIO_PT13_DisableOUTPUT(short int ubit)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ubit;

  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_OUT)+((l_temp&0x01)<<LCDIO_OUT_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_OUT+16))+((l_temp&0x01)<<(LCDIO_OUT_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT13+i*0x04;
    outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT13_GetPortBits (void)
 * function: read PT13 JA
 * input   : NO
 * output  : ^PT13 PORT JA
 * date    : 2021-6-16
 * modify  : ץPT13.1~13.7]m
 ****************************************************************************/
unsigned char DrvGPIO_PT13_GetPortBits (void)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_data=0x00000000;
  for(i=4;i>0;i--)
  {
  l_reg=GPIO_PT13+(i-1)*0x04;
  l_temp=inw(l_reg);
  l_data=l_data<<1;
  l_data=((l_temp>>(LCDIO_DI+16))&0X01)+l_data;
  l_data=l_data<<1;
  l_data=((l_temp>>(LCDIO_DI))&0X01)+l_data;
  }
  return l_data&0xff;
}

/****************************************************************************
 * name    : DrvGPIO_PT13_SetPortBits (unsigned char ui32Data)
 * function: setting PT13 }X1
 * input   : ui32Data:0~0x03,쬰1A~Qĳ]mX1F
 * output  : NO
 * date    : 2021-6-16
 * modify  : ץPT13.1~13.7]m
 ****************************************************************************/
void DrvGPIO_PT13_SetPortBits (unsigned char ui32Data)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ui32Data;

  for(i=0;i<4;i++)
  {
  l_data=(l_data&0x0)+(0x01<<LCDIO_DO)+((l_temp&0x1)<<LCDIO_DO_MASK);
  l_temp=l_temp>>1;
  l_data=(0x01<<(LCDIO_DO+16))+((l_temp&0x1)<<(LCDIO_DO_MASK+16))+l_data;
  l_temp=l_temp>>1;
  l_reg=GPIO_PT13+i*0x04;
  outw(l_reg,l_data);
  }
}

/****************************************************************************
 * name    : DrvGPIO_PT13_ClrPortBits (unsigned int ui32Data)
 * function: setting PT13 }X0
 * input   : ui32Data:0~0x03,쬰1A~Qĳ]mX0F
 * output  : NO
 * date    : 2021-6-16
 * modify  : ץPT13.1~13.7]m
 ****************************************************************************/
void DrvGPIO_PT13_ClrPortBits (unsigned int ui32Data)
{
  unsigned int l_reg,l_data,l_temp;
  unsigned char i;

  l_temp=ui32Data;

  for(i=0;i<4;i++)
  {
    l_data=(l_data&0x0)+(0x0<<LCDIO_DO)+((l_temp&0x1)<<LCDIO_DO_MASK);
    l_temp=l_temp>>1;
    l_data=(0x0<<(LCDIO_DO+16))+((l_temp&0x1)<<(LCDIO_DO_MASK+16))+l_data;
    l_temp=l_temp>>1;
    l_reg=GPIO_PT13+i*0x04;
    outw(l_reg,l_data);
  }
}
