/*
 *  FILE NAME : DrvLCD.h
 *
 *  Created on: 2014/5/31
 *  Author    : 
 */

#ifndef DRVLCD_H_
#define DRVLCD_H_
#include "HY16F391.h"

#ifndef E_FAIL
#define E_FAIL    1
#endif
#define E_DRVLCD_ARGUMENT  E_FAIL
#define E_DRVLCD_ARGUMENT1 0xf0

#ifndef E_SUCCESS
#define E_SUCCESS    0
#endif

#ifdef LCD_BASE
#define LCD_CTRL0  (LCD_BASE+OFFSET00)
#define LCD_CTRL1  (LCD_BASE+OFFSET04)
#define LCD_CTRL2  (LCD_BASE+OFFSET08)
#endif

#ifdef CLOCK_BASE
#define LCD_CLOCK_CTRL  (CLOCK_BASE+OFFSET10)
#endif

#ifdef GPIO_BASE
#define GPIO_LCD0     0x408C8
#define GPIO_LCD1     0x40850
#define GPIO_LCD2     (GPIO_LCD1+OFFSET04)
#define GPIO_LCD3     (GPIO_LCD2+OFFSET04)
#define GPIO_LCD4     (GPIO_LCD3+OFFSET04)
#define GPIO_LCD5     (GPIO_LCD4+OFFSET04)
#define GPIO_LCD6     (GPIO_LCD5+OFFSET04)
#define GPIO_LCD7     (GPIO_LCD6+OFFSET04)
#define GPIO_LCD8     (GPIO_LCD7+OFFSET04)
#define GPIO_LCD9     (GPIO_LCD8+OFFSET04)
#define GPIO_LCD10     (GPIO_LCD9+OFFSET04)
#define GPIO_LCD11     (GPIO_LCD10+OFFSET04)
#define GPIO_LCD12     (GPIO_LCD11+OFFSET04)
#define GPIO_LCD13     (GPIO_LCD12+OFFSET04)
#define GPIO_LCD14     (GPIO_LCD13+OFFSET04)
#define GPIO_LCD15     (GPIO_LCD14+OFFSET04)
#define GPIO_LCD16     (GPIO_LCD15+OFFSET04)
#define GPIO_LCD17     (GPIO_LCD16+OFFSET04)
#define GPIO_LCD18     (GPIO_LCD17+OFFSET04)
#define GPIO_LCD19     (GPIO_LCD18+OFFSET04)
#define GPIO_LCD20     (GPIO_LCD19+OFFSET04)
#define GPIO_LCD21     (GPIO_LCD0+OFFSET04)  //0x408CC


#define VLCD_TRIM      0x042724  //VLCD TRIM CODE DATA      
#endif
  
typedef enum
{
  //E_VLCD24 = 0,
  //E_VLCD26  = 1,
  E_VLCD28  = 2,
  E_VLCD30  = 3,
  E_VLCD33  = 4,
  E_VLCD39  = 5,
  E_VLCD45  = 6,
  E_VLCD50  = 7,
} E_VLCD_MODE;

typedef enum
{
  E_LCD_DUTY3 = 0,
  E_LCD_DUTY4 = 1,
  E_LCD_DUTY5 = 2,
  E_LCD_DUTY6 = 3,
  E_LCD_DUTY7 = 4,
  E_LCD_DUTY8 = 5
} E_LCD_DUTY;

typedef enum
{
  E_LCD_BIAS3 = 0,
  E_LCD_BIAS4 = 1,
} E_LCD_BIAS;


typedef enum
{
  E_LCD_NORMAL  = 0,
  E_LCD_PIXELON = 1,
  E_LCD_PIXELOFF =2
} E_LCD_DISPLAY_MODE;

typedef enum
{
  E_LCD0=0,
  E_LCD1=1,
  E_LCD2=2,
  E_LCD3=3,
  E_LCD4=4,
  E_LCD5=5,
  E_LCD6=6,
  E_LCD7=7,
  E_LCD8=8,
  E_LCD9=9,
  E_LCD10=10,
  E_LCD11=11,
  E_LCD12=12,
  E_LCD13=13,
  E_LCD14=14,
  E_LCD15=15,
  E_LCD16=16,
  E_LCD17=17,
  E_LCD18=18,
  E_LCD19=19,
  E_LCD20=20,
  E_LCD21=21 
}E_LCD_BUFFER;

typedef enum
{
  E_LCD_PT6LEN  = 0,
  E_LCD_PT7LEN  = 1,
  E_LCD_PT8LEN  = 2,
  E_LCD_PT9LEN  = 3,
  E_LCD_PT10LEN = 4,
  E_LCD_PT13LEN = 5,
} E_LCD_IO_PORT;

//0x41B00
#define LCDBS         21
#define IDF           20
#define VLCDEN        19
#define CPCLK         18
#define DSP           16
#define LCDEN         7
#define DUTY          4
#define BEN           3
#define VLCD          0

#define LCDBS_MASK    (LCDBS+MASK)
#define IDF_MASK      (IDF+MASK)
#define DSP_MASK      (DSP+MASK)
#define VLCDEN_MASK   (VLCDEN+MASK)
#define LCDEN_MASK    (LCDEN+MASK)
#define DUTY_MASK     (DUTY+MASK)
#define BEN_MASK      (BEN+MASK)
#define VLCD_MASK     (VLCD+MASK)
#define DUTY_MAX      (0x7)
#define VLCD_MAX      (0x7)
#define DSP_MAX       (0x3)

//0x41B04
#define PT9LEN       24
#define PT8LEN       16
#define PT7LEN       8
#define PT6LEN       0

//0x41B08 
#define COMLEN       28  //PT13LEN
#define PT13LEN      24
#define PT10LEN      0

//0x40310
#define LCDE      1
#define LCDO      4
#define LCKS      0
#define LCDO_MASK  (LCDO+MASK)
#define LCDE_MASK  (LCDE+MASK)
#define LCKS_MASK  (LCKS+MASK)
#define LCDO_MAX    0x7
#define LCDE_MAX    0x7
#define LCD_BUFFER  20

unsigned char DrvLCD_EnableCLK(unsigned int uLCD1,unsigned int uLCD2,unsigned int usource);
unsigned char DrvLCD_DisplayMode(E_LCD_DISPLAY_MODE uDISMODE);
unsigned char DrvLCD_VLCDMode(E_VLCD_MODE uVLCDMODE);
unsigned char DrvLCD_LcdDuty(E_LCD_DUTY uDUTY);
unsigned char DrvLCD_LCDBuffer(unsigned int uBEN);
unsigned char DrvLCD_LCDEnable(unsigned int umode);
unsigned char DrvLCD_VLCDEnable(unsigned int umode);
unsigned char DrvLCD_LCDBias(E_LCD_BIAS ubias);
unsigned char DrvLCD_IOMode(E_LCD_IO_PORT uport,unsigned int uIOMODE);
unsigned char DrvLCD_WriteData(unsigned int uSEG,unsigned int data);
unsigned char DrvLCD_VLCDTrim(short Umode);
#endif /* DRVLCD_H_ */
